"use strict";var e=require("http-status"),t=require("winston"),r=require("joi"),s=require("@aws-sdk/lib-dynamodb"),a=require("@aws-sdk/client-dynamodb"),n=require("@aws-sdk/client-sqs"),o=require("@aws-sdk/client-cognito-identity-provider"),d=require("@middy/core"),i=require("@middy/http-event-normalizer"),u=require("@middy/http-json-body-parser"),m=require("crypto");function l(e){var t=Object.create(null);return e&&Object.keys(e).forEach((function(r){if("default"!==r){var s=Object.getOwnPropertyDescriptor(e,r);Object.defineProperty(t,r,s.get?s:{enumerable:!0,get:function(){return e[r]}})}})),t.default=e,Object.freeze(t)}var c=l(r);class g extends Error{constructor(e,t){super(),this.name="HttpError",this.statusCode=500,this.statusCode=t,"string"==typeof e&&(this.message=e),e instanceof Error&&(this.message=e.message)}}class S extends Error{constructor(e,t,r){super(),this.name="ServiceError",this.code=500,this.statusCode=500,this.code=t||500,this.statusCode=r||500,"string"==typeof e&&(this.message=e),e instanceof Error&&(this.message=e.message)}}class f extends g{constructor(t){super(t||e[`${e.BAD_REQUEST}_MESSAGE`],e.BAD_REQUEST),this.name="BadRequestError"}}function p(e){const{error:t,value:r}=e.validate(process.env,{abortEarly:!1,allowUnknown:!0});if(t)throw console.warn(`Configuration is invalid. Detail: ${t}`),new S(`Configuration validation failed. ${t.message}`);return r}const C=c.object({AWS_EXECUTION_ENV:c.string().required(),AWS_LAMBDA_FUNCTION_NAME:c.string().required(),AWS_LAMBDA_FUNCTION_MEMORY_SIZE:c.string().required(),AWS_LAMBDA_FUNCTION_VERSION:c.string().required(),AWS_REGION:c.string().required(),LOGGING_ENABLED:c.boolean().default(!0),LOGGING_LEVEL:c.string().allow("debug","info","warn","error").default("info")}),E=p(C),h={validateConfig:p},{combine:v,json:y,timestamp:w}=t.format,N={format:v(w(),y()),level:E.LOGGING_LEVEL,silent:!E.LOGGING_ENABLED,transports:[new t.transports.Console]},b=t.createLogger(N);b.debug("Logger::creating new Logger");const I={defaultMessage:"Unhandled error",defaultStatusCode:500},D=e=>{const t={...I,...e};return{onError:e=>{if(void 0!==e.response)return;if(!e.error)return;const{error:r}=e;(e=>e instanceof g)(r)?(b.error(`middleware::http-error-handler::HttpError::${r}`,r),e.response={statusCode:r.statusCode??t.defaultStatusCode,body:JSON.stringify({name:r.name,message:r.message??t.defaultMessage,code:r.statusCode??t.defaultStatusCode,statusCode:r.statusCode??t.defaultStatusCode})}):(e=>e instanceof S)(r)?(b.error(`middleware::http-error-handler::ServiceError::${r}`,r),e.response={statusCode:r.statusCode??t.defaultStatusCode,body:JSON.stringify({name:r.name,message:r.message||t.defaultMessage,code:r.code||t.defaultStatusCode,statusCode:r.statusCode||t.defaultStatusCode})}):(b.error(`middleware::http-error-handler::Error::${r}`,r),e.response={statusCode:t.defaultStatusCode??500,body:JSON.stringify({name:r.name,message:r.message??t.defaultMessage,code:t.defaultStatusCode,statusCode:t.defaultStatusCode})})}}},O=()=>({before:e=>{b.defaultMeta={requestId:e.context.awsRequestId}}}),_={abortEarly:!1,allowUnknown:!0},x=e=>({before:t=>{if(b.debug("middleware::validator::before"),e.eventSchema){const{error:r,value:s}=((e,t)=>e.validate(t,_))(e.eventSchema,t.event);if(r)throw b.error(`middleware::validator::error::${r}`),new f(r.message);t.event={...t.event,...s}}}}),M={region:E.AWS_REGION},A={convertEmptyValues:!1,removeUndefinedValues:!0,convertClassInstanceToMap:!0},G={wrapNumbers:!1},L={marshallOptions:A,unmarshallOptions:G};b.debug("DynamoService::creating new DynamoDBDocumentClient",{data:{dynamoDbClientConfig:M,marshallOptions:A,unmarshallOptions:G}});const U=s.DynamoDBDocumentClient.from(new a.DynamoDBClient(M),L),q={batchWriteItems:e=>U.send(new s.BatchWriteCommand(e)),deleteItem:e=>U.send(new s.DeleteCommand(e)),getItem:e=>U.send(new s.GetCommand(e)),putItem:e=>U.send(new s.PutCommand(e)),queryItems:e=>U.send(new s.QueryCommand(e)),scanItems:e=>U.send(new s.ScanCommand(e)),updateItem:e=>U.send(new s.UpdateCommand(e))},B={region:E.AWS_REGION};b.debug("SQSService::creating new SQSClient",{data:{clientConfig:B}});const R=new n.SQSClient(B),T={sendMessage:e=>R.send(new n.SendMessageCommand(e))},F={send:async(e,t)=>{await T.sendMessage({QueueUrl:t,MessageBody:JSON.stringify({data:e.templateData,destinations:e.destinations,template:e.templateName})})}},W={region:E.AWS_REGION},j=new o.CognitoIdentityProviderClient(W),Q={adminDisableUser:e=>j.send(new o.AdminDisableUserCommand(e)),adminSetUserPassword:e=>j.send(new o.AdminSetUserPasswordCommand(e)),listUsers:e=>j.send(new o.ListUsersCommand(e))},$={generate:(e=16)=>{let t=e;(e<1||e>128)&&(t=16);const r=Math.ceil(t/2);return m.randomBytes(r).toString("hex").substring(0,t)},ID_LENGTH_DEFAULT:16,ID_LENGTH_MAXIMUM:128,ID_LENGTH_MINIMUM:1};exports.BadRequestError=f,exports.CognitoIdentityProviderService=Q,exports.ConfigService=h,exports.DynamoService=q,exports.EmailService=F,exports.ForbiddenError=class extends g{constructor(t){super(t||e[`${e.FORBIDDEN}_MESSAGE`],e.FORBIDDEN),this.name="ForbiddenError"}},exports.HttpError=g,exports.ID=$,exports.Logger=b,exports.NotFoundError=class extends g{constructor(t){super(t||e[`${e.NOT_FOUND}_MESSAGE`],e.NOT_FOUND),this.name="NotFoundError"}},exports.SQSService=T,exports.ServiceError=S,exports.baseConfigSchema=C,exports.baseConfigValues=E,exports.httpErrorHandler=D,exports.loggerInitializer=O,exports.middyfyAPIGateway=e=>d(e.handler).use(O()).use(i()).use(u()).use(x({eventSchema:e.eventSchema})).use(D({defaultMessage:e.defaultErrorMessage,defaultStatusCode:e.defaultErrorStatusCode})),exports.middyfyLambda=e=>d(e.handler).use(O()).use(x({eventSchema:e.eventSchema})),exports.middyfySNS=e=>d(e.handler).use(O()).use(x({eventSchema:e.eventSchema})),exports.middyfySQS=e=>d(e.handler).use(O()).use(x({eventSchema:e.eventSchema})),exports.middyfyScheduled=e=>d(e.handler).use(O()).use(x({eventSchema:e.eventSchema})),exports.validator=x;
//# sourceMappingURL=index.js.map
